#include "stdafx.h"
#include "SVideoArea.h"

SVideoWnd::SVideoWnd()
	:m_userid(_T(""))
	,m_videoid(_T(""))
	,m_isFullScreen(false)
	,m_realwnd(NULL)
{
}

SVideoWnd::~SVideoWnd()
{

}

bool SVideoWnd::IsFullScreen()
{
	return m_isFullScreen;
}


void SVideoWnd::SetIdInfo(SStringT id, SStringT videoid)
{
	m_userid = id;
	m_videoid = videoid;
}


SOUI::SStringT SVideoWnd::GetUserId()
{
	return m_userid;
}

SOUI::SStringT SVideoWnd::GetVideoId()
{
	return m_videoid;
}

///////////////////////SVideoArea/////////////////////////////////

static const unsigned short TOOLBAR_HEIGHT = 0;

template<typename TYPE>
TYPE GetDivValue(TYPE val, TYPE div) {
	TYPE result;
	if (val % div != 0)
		result = val / div + 1;
	else
		result = val / div;

	return result;
}

float GetAccurateDivValue(float val, float div) {
	return val / div;
}
COORDINATE MaxArea(float TotalWidth, float TotalHeight,
	unsigned int Count = 1,
	unsigned int space = 0,
	unsigned int RatioX = 4,
	unsigned int RatioY = 3)
{
	float MaxArea = 0;
	COORDINATE cdnt = { 0 };
	for (unsigned int m = 1; m <= Count; m++) {
		float tWidth;
		float tHeight;
		unsigned int RowOrColumn;

		tHeight = GetAccurateDivValue(TotalHeight, m);
		tWidth = GetAccurateDivValue((tHeight - TOOLBAR_HEIGHT) * RatioX, RatioY);
		RowOrColumn = GetDivValue(Count, m);
		float area = tWidth * tHeight * Count;

		if (MaxArea < area && area <= TotalWidth * TotalHeight &&
			tHeight <= GetAccurateDivValue(TotalHeight, m)
			&& tWidth <= GetAccurateDivValue(TotalWidth, RowOrColumn)) {
			MaxArea = area;
			cdnt.r = m;
			cdnt.c = RowOrColumn;//TotalWidth/tWidth;//GetDivValue(Count,m);
			cdnt.w = tWidth;
			cdnt.h = tHeight;
		}

		tWidth = GetAccurateDivValue(TotalWidth, m);
		tHeight = GetAccurateDivValue(tWidth * RatioY, RatioX) + TOOLBAR_HEIGHT;
		area = tWidth * tHeight * Count;

		if (MaxArea < area && area <= TotalWidth * TotalHeight &&
			tWidth <= GetAccurateDivValue(TotalWidth, m) &&
			tHeight <= GetAccurateDivValue(TotalHeight, RowOrColumn)) {
			MaxArea = area;
			cdnt.r = RowOrColumn;//TotalHeight/tHeight;//GetDivValue(Count,m);
			cdnt.c = m;
			cdnt.w = tWidth;
			cdnt.h = tHeight;
		}
	}
	return cdnt;
}

SVideoArea::SVideoArea()
{
}


SVideoArea::~SVideoArea()
{
}

SVideoWnd* SVideoArea::CreateVideoWnd(SStringT id, SStringT videoid)
{
	//SVideoWnd * pVideownd = new SVideoWnd(id, videoid);
	//return pVideownd;
	return NULL;
}

SVideoWnd* SVideoArea::AddVideo(SStringT id, SStringT videoId)
{
	for (int i = 0; i < m_videoList.size(); i++)
	{
		SVideoWnd* w = m_videoList.at(i);
		if (w->GetUserId() == id && w->GetVideoId() == videoId)
			return NULL;
	}

	SVideoWnd* videownd = dynamic_cast<SVideoWnd*>(CreateChildren(L"<videownd wndclass=\"vidoerendwnd\"  colorBkgnd=\"#ff0000\"/>"));
	if (!videownd)
	{
		//SMessageBox(m_hWnd, L"Ԥʧ", L"", MB_OK, NULL);
	}
	videownd->SetIdInfo(id, videoId);
	m_videoList.push_back(videownd);
	Resize();
	return videownd;
}

void SVideoArea::RemoveVideo(SStringT id, SStringT videoid)
{
	for (std::vector<SVideoWnd*>::iterator iter = m_videoList.begin(); iter != m_videoList.end(); iter++)
	{
		if ((*iter)->GetUserId() == id && (*iter)->GetVideoId() == videoid)
		{
			(*iter)->SetVisible(FALSE, TRUE);
			RemoveChild((*iter));
			(*iter)->Release();
			m_videoList.erase(iter);
			break;
		}
	}
	Resize();
	Invalidate();
}

void SVideoArea::PlayVideo(bool isPlay, SStringT peerId, SStringT videoId)
{
	if (isPlay)
	{
		for (int i = 0; i < m_videoList.size(); i++)
		{
			SVideoWnd* w = m_videoList.at(i);
			if (w->GetUserId() == peerId && w->GetVideoId() == videoId)
				return;
		}
		AddVideo(peerId, videoId);
	}
	else
	{
		RemoveVideo(peerId, videoId);
	}
}

void SVideoArea::SelfLeft()
{
	std::vector<SVideoWnd*>::iterator iter = m_videoList.begin();
	for (; iter != m_videoList.end(); )
	{
		(*iter)->SetVisible(FALSE, TRUE);
		RemoveChild((*iter));
		(*iter)->Release();
		iter = m_videoList.erase(iter);
	}
	Resize();
	Invalidate();
}

void SVideoArea::Resize()
{
	int iCurrentY = 0, iCurrentX = 0;

	CRect rect = GetWindowRect();

	int w = rect.Width();
	int h = rect.Height();
	int Count = m_videoList.size();
	if (Count == 0)return;

	int TotalWidth = rect.Width() - iCurrentX * 2;
	int TotalHeight = rect.Height() - iCurrentY;

	int nIndex = 0;
	COORDINATE cdnt = MaxArea(TotalWidth, TotalHeight, Count);

	iCurrentY += (TotalHeight - int(cdnt.h*cdnt.r)) / 2;
	iCurrentX += (TotalWidth - int(cdnt.w*cdnt.c)) / 2;

	for (int i = 0; i < cdnt.r; i++)
	{
		for (int j = 0; j < cdnt.c && nIndex <= (Count - 1); j++, nIndex++)
		{
			SVideoWnd *pVideoWnd = m_videoList[nIndex];
			if (!pVideoWnd->IsFullScreen())
			{
				pVideoWnd->SetVisible(TRUE);
				pVideoWnd->Move(rect.left+ cdnt.w*(j)+iCurrentX, rect.top + cdnt.h*(i)+iCurrentY, cdnt.w, cdnt.h);
				pVideoWnd->Invalidate();
			}
		}
	}
}

void SVideoArea::OnSize(UINT nType, CSize size)
{
	SWindow::OnSize(nType, size);
	Resize();
}
