#pragma once
#include "core\shostdialog.h"
#include "utils\string.h"
#include <vector>
typedef struct SettingConfig{
	std::string camGuid;
	std::string micGuid;
	std::string spkGuid;
	BOOL       isMirror;
	SettingConfig() {
		camGuid = "";
		micGuid = "";
		spkGuid = "";
		isMirror = FALSE;
	}
}SettingConfig;
class SettingDlg :
	public SHostDialog
{
private:
public:
	SettingDlg();
	~SettingDlg(void);
	BOOL OnInitDialog(HWND wndFocus, LPARAM lInitParam);

	//soui event
	void OnClose();
	void OnOK();
	void OnMusicPlay();
	void OnMusicPause();
	void OnCheckBoxMirror();
	BOOL SliderSoundEvent(EventArgs *pEvt);
	void OnCbVideoInputChange(EventArgs *pEvt);
	void OnCbAudioInputChange(EventArgs *pEvt);
	void OnCbAudioOutputChange(EventArgs *pEvt);
	void OnTimer(char cTimerID);
public:
	void InitDeviceInfo();
	void SetConfig(SettingConfig);
protected:

	//souiϢ
	EVENT_MAP_BEGIN()
		EVENT_NAME_COMMAND(L"btn_close", OnClose)
		EVENT_NAME_COMMAND(L"btn_ok", OnOK)
		EVENT_NAME_COMMAND(L"btn_musicplay", OnMusicPlay)
		EVENT_NAME_COMMAND(L"btn_musicpause", OnMusicPause)
		EVENT_NAME_COMMAND(L"check_mirror", OnCheckBoxMirror)
		EVENT_NAME_HANDLER(L"slider_sound", EVT_SLIDER_POS, SliderSoundEvent);
		EVENT_NAME_HANDLER(L"cb_videoinput", EventCBSelChange::EventID, OnCbVideoInputChange)
		EVENT_NAME_HANDLER(L"cb_audioinput", EventCBSelChange::EventID, OnCbAudioInputChange)
		EVENT_NAME_HANDLER(L"cb_audiooutput", EventCBSelChange::EventID, OnCbAudioOutputChange)
	EVENT_MAP_END()
		//HostWndʵϢ
	BEGIN_MSG_MAP_EX(SHostDialog)
		MSG_WM_INITDIALOG(OnInitDialog)
		MSG_WM_TIMER_EX(OnTimer)
		CHAIN_MSG_MAP(SHostDialog)
		REFLECT_NOTIFICATIONS_EX()
	END_MSG_MAP()
public:
	static SettingConfig         m_settingConfig;
private:
	std::vector<std::string> m_videoIdList;
	std::vector<std::string> m_micIdList;
	std::vector<std::string> m_spkIdList;
	bool m_bInited;
	int m_soundcurtime;
	////////////ui 
	SComboBox* m_camComBox;
	SComboBox* m_micComBox;
	SComboBox* m_spkComBox;

	bool m_bLayoutInited = false;



};


