#include "stdafx.h"
#include "ShareScreenDlg.h"
#include "App.h"
#include <vector>
#define CAP_WND_CAPTION_H		20
#define CAP_WND_BORDER_W		8
DesktopSource ShareScreenDlg::m_desktopSource = DesktopSource();
ShareScreenDlg::ShareScreenDlg():SHostWnd(_T("LAYOUT:XML_SHARESCREENDLG"))
{
	m_shareType = 0;
	m_regionHwnd = NULL;
	m_screenPushing = false;
}


ShareScreenDlg::~ShareScreenDlg()
{
	::PostMessage(m_regionHwnd, WM_CLOSE, NULL, NULL);
	m_regionHwnd = NULL;
	App::sdk()->stopShareScreen();
}

void ShareScreenDlg::OnClose()
{
	m_screenPushing = false;
	::ShowWindow(m_regionHwnd, SW_HIDE);
	ShowWindow(SW_HIDE);
}

void ShareScreenDlg::OnStartShare()
{
	//SMessageBox(m_hWnd, _T("text"), _T("OnStartShare"), 1);

	m_desktopSource.mixMic = true;
	m_desktopSource.mixSpeaker = true;
	switch (m_shareType)
	{
	case 0:{
		//program
		SComboBox *pProgramCombox = FindChildByName2<SComboBox>("cb_selectprogram");
		m_desktopSource.window = (void*)m_vectWindows[pProgramCombox->GetCurSel()].id;
		m_desktopSource.type = TK_SOURCE_WINDOW;
		m_desktopSource.rect = {0,0,0,0};
		m_desktopSource.cursorMonitor = true;
		App::sdk()->startShareScreen(m_desktopSource);
		break;
	}
	case 1: {
		//screen
		m_desktopSource.type = TK_SOURCE_SCREEN;
		std::vector<ValidWindow> list;
		App::sdk()->getValidWindowList(list, (TK_SOURCETYPE)m_desktopSource.type);
		m_desktopSource.window = (void*)list[0].id;
		m_desktopSource.cursorMonitor = true;
		m_desktopSource.rect = { 0,0,0,0 };
		App::sdk()->startShareScreen(m_desktopSource);
		break;
	}
	case 2: {
		//region
		m_desktopSource.type = TK_SOURCE_SCREEN;
		std::vector<ValidWindow> list;
		App::sdk()->getValidWindowList(list, (TK_SOURCETYPE)m_desktopSource.type);
		m_desktopSource.window = (void*)list[0].id;
		m_desktopSource.cursorMonitor = true;
		App::sdk()->startShareScreen(m_desktopSource);

		break;
	}
	default:
		break;
	}
	m_screenPushing = true;
	App::mainInstance()->SetShareScreenState(m_screenPushing);
	//OnOK();
	ShowWindow(SW_HIDE);
}

void ShareScreenDlg::OnStopShare()
{
	App::sdk()->stopShareScreen();
	m_screenPushing = false;
	::ShowWindow(m_regionHwnd, SW_HIDE);
	App::mainInstance()->SetShareScreenState(m_screenPushing);
}

DesktopSource ShareScreenDlg::GetDesktopSource()
{
	return m_desktopSource;
}

bool ShareScreenDlg::IsScreenPushing()
{
	return m_screenPushing;
}

void ShareScreenDlg::OnCbSelectProgramchange(EventArgs *e)
{
	EventCBSelChange *e2 = sobj_cast<EventCBSelChange>(e);
	SComboBox *pCbx = sobj_cast<SComboBox>(e2->sender);
	if (e2->nCurSel != -1)
	{
		SStringT str = pCbx->GetLBText(e2->nCurSel);

	}
}

BOOL ShareScreenDlg::OnInitDialog(HWND wndFocus, LPARAM lInitParam)
{
	InitRegionWnd();
	App::sdk()->getValidWindowList(m_vectWindows, TK_SOURCE_WINDOW);
	SComboBox *pProgramCombox = FindChildByName2<SComboBox>("cb_selectprogram");
	pProgramCombox->ResetContent();
	for (int i = 0; i < m_vectWindows.size(); i++)
	{
		ValidWindow vw = m_vectWindows[i];
		pProgramCombox->InsertItem(i, S_UTF82T(vw.title.data()), 0, 0);
	}
	pProgramCombox->SetCurSel(0);
	return FALSE;
}

void ShareScreenDlg::OnShareWndClicked(EventArgs *pEvt)
{
	EventCmd *evt = (EventCmd *)pEvt;
	SWindow *pBtn = (SWindow *)evt->sender;
	SStringT name = pBtn->GetName();
	SImageWnd* pProgramCheckImg = FindChildByName2<SImageWnd>("program_check");
	SImageWnd* pProgramunCheckImg = FindChildByName2<SImageWnd>("program_uncheck");
	SImageWnd* pScreenCheckImg   = FindChildByName2<SImageWnd>("screen_check");
	SImageWnd* pScreenunCheckImg = FindChildByName2<SImageWnd>("screen_uncheck");
	SImageWnd* pRegionCheckImg = FindChildByName2<SImageWnd>("region_check");
	SImageWnd* pRegionunCheckImg = FindChildByName2<SImageWnd>("region_uncheck");
	SWindow* pWndProgram = FindChildByName2<SWindow>("wnd_program");
	if (name == _T("win_program"))
	{
		m_shareType = 0;
		pWndProgram->SetAttribute(_T("show"),_T("1"));
		pProgramCheckImg->SetVisible(TRUE);
		pProgramunCheckImg->SetVisible(FALSE);
		pScreenCheckImg->SetVisible(FALSE);
		pScreenunCheckImg->SetVisible(TRUE);
		pRegionCheckImg->SetVisible(FALSE);
		pRegionunCheckImg->SetVisible(TRUE);
		::ShowWindow(m_regionHwnd, SW_HIDE);
	}
	else if (name == _T("win_screen")) {
		m_shareType = 1;
		pWndProgram->SetAttribute(_T("show"), _T("0"));
		pProgramCheckImg->SetVisible(FALSE);
		pProgramunCheckImg->SetVisible(TRUE);
		pScreenCheckImg->SetVisible(TRUE);
		pScreenunCheckImg->SetVisible(FALSE);
		pRegionCheckImg->SetVisible(FALSE);
		pRegionunCheckImg->SetVisible(TRUE);
		::ShowWindow(m_regionHwnd, SW_HIDE);

	}
	else if(name == _T("win_region")){
		m_shareType = 2;
		pWndProgram->SetAttribute(_T("show"), _T("0"));
		pProgramCheckImg->SetVisible(FALSE);
		pProgramunCheckImg->SetVisible(TRUE);
		pScreenCheckImg->SetVisible(FALSE);
		pScreenunCheckImg->SetVisible(TRUE);
		pRegionCheckImg->SetVisible(TRUE);
		pRegionunCheckImg->SetVisible(FALSE);
		int nMaximizedWidth, nMaximizedHeight;
		nMaximizedWidth = GetSystemMetrics(SM_CXMAXIMIZED);
		nMaximizedHeight = GetSystemMetrics(SM_CYMAXIMIZED);
		int regionWidth = nMaximizedWidth / 4, regionHeight = nMaximizedHeight / 4;
		::MoveWindow(m_regionHwnd, (nMaximizedWidth - regionWidth) / 2, (nMaximizedHeight - regionHeight) / 2, regionWidth, regionHeight,FALSE);
		::ShowWindow(m_regionHwnd, SW_NORMAL);
// 		ShareScreenDlg::m_desktopSource.rect = { (x + CAP_WND_BORDER_W, y + CAP_WND_CAPTION_H, wid - CAP_WND_BORDER_W * 2, hei - CAP_WND_CAPTION_H - CAP_WND_BORDER_W) };
// 		App::sdk()->updateShareScreen(m_desktopSource);
	}
	pWndProgram->Invalidate();
	pProgramCheckImg->Invalidate();
	pProgramunCheckImg->Invalidate();
	pScreenCheckImg->Invalidate();
	pScreenunCheckImg->Invalidate();
	pRegionCheckImg->Invalidate();
	pRegionunCheckImg->Invalidate();
	pBtn->Invalidate();
}

void ShareScreenDlg::InitRegionWnd()
{
	WNDCLASSEX wcex_cap = {
		/* cbSize = */ sizeof(WNDCLASSEX),
		/* style = */ CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS /*| CS_SAVEBITS*/ | CS_GLOBALCLASS,
		/* lpfnWndProc = */ RegionWindowProc,
		/* cbClsExtra = */ 0,
		/* cbWndExtra = */ 0,
		/* hInstance = */ GetModuleHandle(NULL),
		/* hIcon = */ NULL,
		/* hCursor = */ LoadCursor(NULL, IDC_ARROW),
		/* hbrBackground = */ CreateSolidBrush(RGB(0, 255, 255)),
		/* lpszMenuName = */ NULL,
		/* lpszClassName = */ _T("_CapWindowClass"),
		/* hIconSm = */ NULL,
	};
	RegisterClassEx(&wcex_cap);
	int nMaximizedWidth, nMaximizedHeight;
	nMaximizedWidth = GetSystemMetrics(SM_CXMAXIMIZED);
	nMaximizedHeight = GetSystemMetrics(SM_CYMAXIMIZED);
	int regionWidth = nMaximizedWidth/4, regionHeight = nMaximizedHeight/4;
	m_regionHwnd = CreateWindowEx(WS_EX_TOPMOST | WS_EX_TOOLWINDOW | WS_EX_LTRREADING, _T("_CapWindowClass"), _T(""),
		(WS_DISABLED | WS_OVERLAPPED),
		//w_x, w_y, w_wid, w_hei,
		(nMaximizedWidth - regionWidth)/2, (nMaximizedHeight - regionHeight) / 2, regionWidth, regionHeight,
		NULL, NULL, GetModuleHandle(NULL), NULL);

	HRGN full_rgn = CreateRectRgn(0, 0, regionWidth, regionHeight);
	HRGN rgn = CreateRectRgn(CAP_WND_BORDER_W, CAP_WND_CAPTION_H, regionWidth - CAP_WND_BORDER_W, regionHeight - CAP_WND_BORDER_W);
	CombineRgn(full_rgn, full_rgn, rgn, RGN_DIFF);
	::SetWindowRgn(m_regionHwnd, full_rgn, TRUE);
	//ȥ߿ʽ
	::SetWindowLong(m_regionHwnd, GWL_STYLE, WS_OVERLAPPED);
	::SetWindowLong(m_regionHwnd, GWL_EXSTYLE, WS_EX_TOPMOST | WS_EX_TOOLWINDOW | WS_EX_LTRREADING);
	::ShowWindow(m_regionHwnd, SW_HIDE);
}
LRESULT CALLBACK ShareScreenDlg::RegionWindowProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
	HDC hdc;
	RECT wr;
	::GetWindowRect(hwnd, &wr);;
	HRGN full_rgn = NULL, rgn = NULL;
	int x = wr.left, y = wr.top, wid = wid = wr.right - wr.left, hei = hei = wr.bottom - wr.top;
	int systemX = GetSystemMetrics(SM_CXSCREEN), systemY = GetSystemMetrics(SM_CYSCREEN);
	MINMAXINFO* mmi = NULL;
	switch (uMsg) {
	case WM_NCHITTEST:
	{
		POINT pt = { 0, 0 };
		::ClientToScreen(hwnd, &pt);
		POINT point = { GET_X_LPARAM(lParam),GET_Y_LPARAM(lParam) };
		int RESIZE_REGION_SIZE = 10;
		RECT rcWindow;
		::GetWindowRect(hwnd, &rcWindow);
		// ýĸǵжϷǰ  
		if (point.x <= rcWindow.left + RESIZE_REGION_SIZE && point.y <= rcWindow.top + RESIZE_REGION_SIZE)
			return HTTOPLEFT;
		else if (point.x >= rcWindow.right - RESIZE_REGION_SIZE && point.y <= rcWindow.top + RESIZE_REGION_SIZE)
			return HTTOPRIGHT;
		else if (point.x <= rcWindow.left + RESIZE_REGION_SIZE && point.y >= rcWindow.bottom - RESIZE_REGION_SIZE)
			return HTBOTTOMLEFT;
		else if (point.x >= rcWindow.right - RESIZE_REGION_SIZE && point.y >= rcWindow.bottom - RESIZE_REGION_SIZE)
			return HTBOTTOMRIGHT;
		else if (point.x <= rcWindow.left + RESIZE_REGION_SIZE)
			return HTLEFT;
		else if (point.x >= rcWindow.right - RESIZE_REGION_SIZE)
			return HTRIGHT;
		else if (point.y <= rcWindow.top + RESIZE_REGION_SIZE)
			return HTTOP;
		else if (point.y >= rcWindow.bottom - RESIZE_REGION_SIZE)
			return HTBOTTOM;
		break;
	}
	case WM_PAINT:
	{
		PAINTSTRUCT ps;
		HDC hdc;   // DC(ɻͼڴ) ľ
				   // ͨھȡôڵ DC
		hdc = BeginPaint(hwnd, &ps);
		RECT rect;
		::GetClientRect(hwnd, &rect);
		HPEN hpen = CreatePen(PS_SOLID, 1, RGB(0, 255, 0));
		HBRUSH hb = CreateSolidBrush(RGB(0, 255, 0));
		SelectObject(hdc, hpen);
		SelectObject(hdc, hb);
		Rectangle(hdc, 8, 8, rect.right - rect.left - 8, 20);
		DeleteObject(hpen);
		DeleteObject(hb);
		EndPaint(hwnd, &ps);
		break;

	}
	case WM_LBUTTONDOWN:
	{
		POINT point = { GET_X_LPARAM(lParam),GET_Y_LPARAM(lParam) };
		::SendMessage(hwnd, WM_NCLBUTTONDOWN, HTCAPTION, MAKELPARAM(point.x, point.y));
		break;
	}
	case WM_SIZE:
		full_rgn = CreateRectRgn(0, 0, wid, hei);
		rgn = CreateRectRgn(CAP_WND_BORDER_W, CAP_WND_CAPTION_H, wid - CAP_WND_BORDER_W, hei - CAP_WND_BORDER_W);
		CombineRgn(full_rgn, full_rgn, rgn, RGN_DIFF);
		::SetWindowRgn(hwnd, full_rgn, TRUE);
		ShareScreenDlg::m_desktopSource.rect = { x + CAP_WND_BORDER_W, y + CAP_WND_CAPTION_H, wid - CAP_WND_BORDER_W * 2, hei - CAP_WND_CAPTION_H - CAP_WND_BORDER_W};
		App::sdk()->updateShareScreen(m_desktopSource);
		//Tools::Inst()->OnUpdateWindowPos(x + CAP_WND_BORDER_W, y + CAP_WND_CAPTION_H, wid - CAP_WND_BORDER_W * 2, hei - CAP_WND_CAPTION_H - CAP_WND_BORDER_W);
		break;
	case WM_MOVE:
		if (x < 0) {
			::SetWindowPos(hwnd, HWND_TOPMOST, 0, wr.top, wid, hei, SWP_SHOWWINDOW);
			x = 0;
		}
		if (wr.right > systemX) {
			::SetWindowPos(hwnd, HWND_TOPMOST, systemX - wid, wr.top, wid, hei, SWP_SHOWWINDOW);
			x = systemX - wid;
		}
		if (wr.bottom > systemY) {
			::SetWindowPos(hwnd, HWND_TOPMOST, wr.left, systemY - hei, wid, hei, SWP_SHOWWINDOW);
			y = systemY - hei;
		}
		ShareScreenDlg::m_desktopSource.rect = { x + CAP_WND_BORDER_W, y + CAP_WND_CAPTION_H, wid - CAP_WND_BORDER_W * 2, hei - CAP_WND_CAPTION_H - CAP_WND_BORDER_W };
		App::sdk()->updateShareScreen(m_desktopSource);
		//Tools::Inst()->OnUpdateWindowPos(x + CAP_WND_BORDER_W, y + CAP_WND_CAPTION_H, wid - CAP_WND_BORDER_W * 2, hei - CAP_WND_CAPTION_H - CAP_WND_BORDER_W);
		break;
	case WM_GETMINMAXINFO:
		mmi = (MINMAXINFO*)lParam;
		mmi->ptMinTrackSize.x = 100;
		mmi->ptMinTrackSize.y = 100;
		break;
	case WM_CLOSE:
		::DestroyWindow(hwnd);
		break;
	case WM_DESTROY:
		//PostQuitMessage(0);
		break;
	}
	return ::DefWindowProc(hwnd, uMsg, wParam, lParam);
}

void ShareScreenDlg::OnUpdateWindowPos(int x, int y, int width, int height)
{
	m_desktopSource.rect = { x, y, width, height };
	App::sdk()->updateShareScreen(m_desktopSource);
}

void ShareScreenDlg::OnShowWindow(BOOL bShow, UINT nStatus)
{
	if (bShow)
	{
		if (m_shareType == 2)
		{
			//region
			::ShowWindow(m_regionHwnd, SW_NORMAL);
		}
	}
}
