#pragma once
#include "core\shostdialog.h"
#include "tkdefinition.h"
class ShareScreenDlg :
	public SHostWnd
{
private:
public:
	ShareScreenDlg();
	~ShareScreenDlg(void);
	void OnClose();
	void OnStartShare();
	void OnStopShare();
	DesktopSource GetDesktopSource();
	bool IsScreenPushing();
protected:
	void OnCbSelectProgramchange(EventArgs *e);
	BOOL OnInitDialog(HWND wndFocus, LPARAM lInitParam);
	void OnShareWndClicked(EventArgs *pEvt);
	void InitRegionWnd();
	static LRESULT CALLBACK RegionWindowProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
	void OnUpdateWindowPos(int x, int y, int width, int height);
	void OnShowWindow(BOOL bShow, UINT nStatus);
public:
protected:

	//souiϢ
	EVENT_MAP_BEGIN()
		EVENT_NAME_COMMAND(L"btn_close", OnClose)
		EVENT_NAME_COMMAND(L"btn_startshare", OnStartShare)
		EVENT_NAME_HANDLER(L"cb_selectprogram", EventCBSelChange::EventID, OnCbSelectProgramchange)
		EVENT_NAME_HANDLER(L"win_program", EVT_CMD, OnShareWndClicked)
		EVENT_NAME_HANDLER(L"win_screen", EVT_CMD, OnShareWndClicked)
		EVENT_NAME_HANDLER(L"win_region", EVT_CMD, OnShareWndClicked)

		EVENT_MAP_END()
		//HostWndʵϢ
		BEGIN_MSG_MAP_EX(SHostWnd)
		MSG_WM_INITDIALOG(OnInitDialog)
		MSG_WM_SHOWWINDOW(OnShowWindow)
		CHAIN_MSG_MAP(SHostWnd)
		REFLECT_NOTIFICATIONS_EX()
		END_MSG_MAP()
private:
	std::vector<ValidWindow> m_vectWindows;
	int m_shareType; //0 share program,1 share screen , 2 share region
	int m_shareId;
	bool m_screenPushing;
	static DesktopSource m_desktopSource;
	HWND m_regionHwnd;
};


