#include "stdafx.h"
#include "UserListWnd.h"
#include "App.h"
#include "MainDlg.h"
#include <helper/SAdapterBase.h>
typedef struct ButtonData 
{
	int row;
	int deviceserial;
	ButtonData() {
		row = 0;
		deviceserial = 0;
	}
};
class CAdapterFix : public SAdapterBase
{
private:
	std::vector<UserInfo>* m_userlist;
	HWND m_ReceiveMsgHwnd;
public:

	CAdapterFix()
	{
		m_userlist = NULL;
		m_ReceiveMsgHwnd = NULL;
	}

	~CAdapterFix()
	{
	}
	void SetUserList(std::vector<UserInfo>* userlist)
	{
		m_userlist = userlist;
	}
	virtual int getCount()
	{
		if (!m_userlist)
		{
			return 0;
		}
		return (*m_userlist).size();
	}

	virtual void getView(int position, SWindow * pItem, pugi::xml_node xmlTemplate)
	{
		if (pItem->GetChildrenCount() == 0)
		{
			pItem->InitFromXml(xmlTemplate);
		}
		UserInfo userinfo = m_userlist->at(position);
		//TKRoomUserPtr userPtr = m_userlist->at(position).roomuserPtr;

		SStatic *pTxtNickName = pItem->FindChildByName2<SStatic>(L"txt_nickname");
		SStringT nickName =  S_UTF82T(userinfo.roomuserPtr->getNickName().data());
		pTxtNickName->SetWindowText(S_UTF82T(userinfo.roomuserPtr->getNickName().data()));

		SButton *pBtn = pItem->FindChildByName2<SButton>(L"btn_shutvideo");
// 		ButtonData *pbtnData = new ButtonData;
// 		pbtnData->row = position;
		pBtn->GetRoot()->SetUserData(position);
		pBtn->GetEventSet()->subscribeEvent(&CAdapterFix::OnShutVideo, this);


		SButton *pShutAudioBtn = pItem->FindChildByName2<SButton>(L"btn_shutaudio");
		pShutAudioBtn->GetRoot()->SetUserData(position);
		pShutAudioBtn->GetEventSet()->subscribeEvent(&CAdapterFix::OnShutAudio, this);

		SButton *pKickOutBtn = pItem->FindChildByName2<SButton>(L"btn_user_kickout");
		if (userinfo.roomuserPtr->getPeerID() == App::getId())
		{
			pKickOutBtn->SetVisible(FALSE);
		}
		else {
			pKickOutBtn->GetRoot()->SetUserData(position);
			pKickOutBtn->GetEventSet()->subscribeEvent(&CAdapterFix::OnKickOut, this);
		}

	}


	bool OnShutVideo(EventCmd *pEvt)
	{
		SButton *pBtn = sobj_cast<SButton>(pEvt->sender);
// 		ButtonData *pbtnData  = (ButtonData *)pBtn->GetRoot()->GetUserData();
// 		int iItem = pbtnData->row;
		int iItem = pBtn->GetRoot()->GetUserData();
		UserInfo userinfo = m_userlist->at(iItem);

		static bool bshut = false;
		if (!bshut)
		{
			pBtn->SetAttribute(_T("skin"), _T("skin_openvideo_png"));
			bshut = true;
			::PostMessage(m_ReceiveMsgHwnd, MSG_SHUTVIDEO, iItem,NULL);
		} 
		else
		{
			bshut = false;
			pBtn->SetAttribute(_T("skin"), _T("skin_shutvideo_png"));
			::PostMessage(m_ReceiveMsgHwnd, MSG_OPENVIDEO, iItem, NULL);
		}
		pBtn->Invalidate();
		notifyItemDataChanged(iItem);
		return true;
	}

	bool OnShutAudio(EventCmd *pEvt)
	{
		SButton *pBtn = sobj_cast<SButton>(pEvt->sender);
		int iItem = pBtn->GetRoot()->GetUserData();
		UserInfo userinfo = m_userlist->at(iItem);
		static bool bshut = false;
		if(userinfo.bPlayAudio)
		{
			pBtn->SetAttribute(_T("skin"), _T("skin_openaudio_png"));
			::PostMessage(m_ReceiveMsgHwnd, MSG_SHUTAUDIO,(WPARAM)iItem,NULL);
		}
		else
		{
			pBtn->SetAttribute(_T("skin"), _T("skin_shutaudio_png"));
			::PostMessage(m_ReceiveMsgHwnd, MSG_OPENAUDIO, (WPARAM)iItem, NULL);
		}
		return true;
	}
	
	bool OnKickOut(EventCmd *pEvt)
	{
		SButton *pBtn = sobj_cast<SButton>(pEvt->sender);
		int iItem = pBtn->GetRoot()->GetUserData();
		UserInfo userinfo = m_userlist->at(iItem);
		::PostMessage(m_ReceiveMsgHwnd, MSG_KICKOUT, (WPARAM)iItem, NULL);
		return true;
	}
	void InvalidateDate()
	{
		notifyDataSetChanged();
	}
	void SetReceiveMsgHwnd(HWND hWnd)
	{
		m_ReceiveMsgHwnd = hWnd;
	}
};


UserListWnd::UserListWnd() :SHostWnd(_T("LAYOUT:XML_USERLISTDLG"))
{
	m_pLstViewFix = NULL;
}


UserListWnd::~UserListWnd()
{
}

BOOL UserListWnd::OnInitDialog(HWND wndFocus, LPARAM lInitParam)
{
	//и߹̶б
	m_pLstViewFix = FindChildByName2<SListView>("lv_userlist");
	if (m_pLstViewFix)
	{
		ILvAdapter *pAdapter = new CAdapterFix;
		m_pLstViewFix->SetAdapter(pAdapter);
		pAdapter->Release();
	}
	return TRUE;
}

void UserListWnd::SetUserList(std::vector<UserInfo>* userlist)
{
	if (m_pLstViewFix)
	{
		CAdapterFix *pAdapterfix = (CAdapterFix*)m_pLstViewFix->GetAdapter();
		pAdapterfix->SetUserList(userlist);
	}else{
		printf("listview not inited");
	}
}

void UserListWnd::UpdateList()
{
	CAdapterFix *pAdapterfix = (CAdapterFix*)m_pLstViewFix->GetAdapter();
	pAdapterfix->InvalidateDate();
}

void UserListWnd::RegisterWnd(HWND hWnd)
{
	if (m_pLstViewFix)
	{
		CAdapterFix *pAdapterfix = (CAdapterFix*)m_pLstViewFix->GetAdapter();
		pAdapterfix->SetReceiveMsgHwnd(hWnd);
	}
	else {
		printf("listview not inited");
	}
	m_parentHwnd = hWnd;
}

void UserListWnd::OnShowWindow(BOOL bShow, UINT nStatus)
{
	if (m_pLstViewFix)
	{
		CAdapterFix *pAdapterfix = (CAdapterFix*)m_pLstViewFix->GetAdapter();
		pAdapterfix->InvalidateDate();
	}
}

void UserListWnd::OnKillFocus(HWND wndFocus)
{
	ShowWindow(SW_HIDE);
}
