#pragma once
#include "tkroomuser.h"

class TKRoomManagerObserver
{
public:
	// ɹ뷿
	virtual void onRoomJoined() = 0;

	// Ѿ뿪
	virtual void onRoomLeaved() = 0;

	virtual void onConnectionLost() {};

	// 뷿
	// error룬붨
	virtual void onError(int error) = 0;

	// joinRoomģȡȡĵĻصеĴ
	// errorCode
	// errMsgϢ
	virtual void onError(int errorCode, const std::string& errMsg) = 0;

	virtual void onWarning(int warningCode) {};

    virtual void onInfo(int infoCode, const tk::Variant& info = tk::Variant()) {};

	// û뷿
	// userûṹ
	// inListtrueԼ֮ǰ룻falseԼ֮
	virtual void onUserJoined(TKRoomUserPtr peer, bool inList) = 0;

	// û뿪
	// userûṹ
	virtual void onUserLeft(TKRoomUserPtr peer) = 0;

	// ûԷ˱仯
	// userûṹ
	// changedProperties仯
	virtual void onUserPropertyChanged(tk_uid peerId,const std::string& key,const tk::Variant& value) = 0;

	virtual void onUserVideoStatus(tk_uid peerId, TK_MEDIA_STATUS state) = 0;
	virtual void onUserVideoStatus(tk_uid peerId, std::string deviceId,TK_MEDIA_STATUS state) {
		TKUNUSED(peerId);
		TKUNUSED(deviceId);
		TKUNUSED(state);
	};
	virtual void onUserAudioStatus(tk_uid peerId, TK_MEDIA_STATUS state) = 0;

	virtual void onShareMediaState(tk_uid peerId, TK_MEDIA_STATUS state) = 0;

	virtual void onShareScreenState(tk_uid peerId, TK_MEDIA_STATUS state) = 0;
	// յϢ
	// userû
	// messageϢ
	virtual void onMessageReceived(tk_uid peerId, const std::string& message, const tk::VariantMap& extendJson) {};

	// յԶϢ
	// addtrueϢfalseɾϢ
	// idϢid
	// nameϢ
	// tsϢʱ
	// dataϢݣNumberStringMapList
	virtual void onRemotePubMsg(std::string msgid, std::string msgname, tk_uid fromId, tk_uid toId, tk::Variant data, tk_uid associatedUserID
		, const std::string& associatedMsgID , long ts) {
		TKUNUSED(msgid);
		TKUNUSED(msgname);
		TKUNUSED(fromId);
		TKUNUSED(toId);
		TKUNUSED(data);
		TKUNUSED(ts);
	}
	virtual void onRemoteDelMsg(std::string msgid, std::string msgname, tk_uid fromId, tk_uid toId, tk::Variant data, tk_uid associatedUserID
		, const std::string& associatedMsgID, long ts) {
		TKUNUSED(msgid);
		TKUNUSED(msgname);
		TKUNUSED(fromId);
		TKUNUSED(toId);
		TKUNUSED(data);
		TKUNUSED(ts);
	}

	// 
	virtual void onKickedout(TK_KICKOUT_REASON reason) {
		TKUNUSED(reason);
	}
	// Ƶֱʷ仯
	virtual void onVideoSizeChange(tk_uid peerId,int w,int h) {
		TKUNUSED(peerId);
		TKUNUSED(w);
		TKUNUSED(h);
	}
	/* video stats report
	@param stats  video stats
	@param peerId user id
	@param mediaType   == "media"  remote media file video frame
						== "screen" remote screen frame
						default is empty , if TKMULTILOCALSTREAM == true camera device id
	*/
	virtual void onVideoStatsReport(const VideoStats& stats,tk_uid peerId, const std::string& type) {
		TKUNUSED(peerId);
		TKUNUSED(type);
		TKUNUSED(stats);
	}
	/* audio stats report
	@param stats video stats
	@param peerId  user id
	@param id   == TK_MEDIA_FILE   media file audio frame
			    == TK_MEDIA_SCREEN  screen audio frame(order by DesktopSource)
		        or TK_MEDIA_MIC   microphone audio frame
	*/
	virtual void onAudioStatsReport(const AudioStats& stats,tk_uid peerId, TK_MEDIATYPE mediaType) {
		TKUNUSED(peerId);
		TKUNUSED(stats);
		TKUNUSED(mediaType);
	}

	/* stats report
	@param stats  audio and video stats
	*/
	virtual void onRtcStatsReport(const RtcStats& stats) {
		TKUNUSED(stats);
	}
	
	/* local microphone volume real time report [0~32768] 
	@param vol   microphone volume
	*/
	virtual void onMicVolumeReport(int vol) {
		TKUNUSED(vol);
	}

	/* remote user audio volume  real time report [0~32768]
	@param peerId remote user id
	@param vol    remote user volume 
	*/
	virtual void onRemoteAudioVolume(tk_uid peerId, int vol) {
		TKUNUSED(peerId);
		TKUNUSED(vol);
	}

	/* media file captured progress, if you call startShareMediaFile ,can receive this call back
	@param pos   current pos
	@param total  media file total duration
	*/
	virtual void onMediaFileProgress(uint64_t pos, uint64_t total) {
		TKUNUSED(pos);
		TKUNUSED(total);
	}

	/* switch room to only audio or video and audio call back
	@param from   switched user id
	@param onlyAudio    only audio or video and audio
	*/
	virtual void onAudioRoomSwitch(tk_uid from,bool onlyAudio) {
		TKUNUSED(from);
		TKUNUSED(onlyAudio);
	}
	/* first video frame come
	@param width video frame width
	@param height video frame height
	@param peerId  user id
	@param mediaType   == "media"  remote media file video frame
						== "screen" remote screen frame
						default is empty , if TKMULTILOCALSTREAM == true camera device id
	*/
	virtual void onFirstVideoFrame(int width, int height,tk_uid peerId, std::string mediaType) {
		TKUNUSED(peerId);
		TKUNUSED(mediaType);
		TKUNUSED(width);
		TKUNUSED(height);
	};
	/* first audio frame come
	@param peerId  user id
	@param id   == TK_MEDIA_FILE   media file audio frame
				== TK_MEDIA_SCREEN  screen audio frame(order by DesktopSource)
				or TK_MEDIA_MIC   microphone audio frame
	*/
	virtual void onFirstAudioFrame(tk_uid peerId, TK_MEDIATYPE mediaType) {
		TKUNUSED(peerId);
		TKUNUSED(mediaType);
	};
	/* video state change
	@param connectionId  user id
	@param id  == "media"  remote media file video frame
			   == "screen" remote screen frame
			   default is empty , if TKMULTILOCALSTREAM == true camera device id
	@param state  frozen or resume
	*/
	virtual void onVideoStateChanged(std::string connectionId, std::string id, TK_MEDIA_STATE state) {
		TKUNUSED(connectionId);
		TKUNUSED(id);
		TKUNUSED(state);
	};
	/* audio state change
	@param connectionId  user id
	@param mediaType  == TK_MEDIA_FILE   media file audio frame
				      == TK_MEDIA_SCREEN  screen audio frame(order by DesktopSource)
				      or TK_MEDIA_MIC
	@param state  frozen or resume
	*/
	virtual void onAudioStateChanged(std::string connectionId, TK_MEDIATYPE mediaType, TK_MEDIA_STATE state) {
		TKUNUSED(connectionId);
		TKUNUSED(mediaType);
		TKUNUSED(state);
	};

	/**
	* when the video device state changed(plugged or removed), the function will be called
	* @param [in] deviceId
	*        the ID of the state changed video device
	* @param [in] deviceState
	*        the device is been removed or added
	*/
	virtual void onVideoDeviceStateChanged(const std::string& deviceId, TK_DEVICE_STATE deviceState) {
		TKUNUSED(deviceId);
		TKUNUSED(deviceState);
	}
	/**
	* when the audio device state changed(plugged or removed), the function will be called
	* @param [in] deviceId
	*        the ID of the state changed audio device
	* @param [in] deviceType
	*        the type of the audio device(playout device or record device)
	* @param [in] deviceState
	*        the device is been removed or added
	*/
	virtual void onAudioDeviceStateChanged(const std::string& deviceId, TK_AUDIO_DEVICE deviceType, TK_DEVICE_STATE deviceState) {
		TKUNUSED(deviceId);
		TKUNUSED(deviceType);
		TKUNUSED(deviceState);
	}
    
    virtual void onNetworkQuality(int64_t rttMs, TK_NET_QUALITY referenceQuality) {};
    
	/** 
	* Room event which is triggered when the number of users reaches a certain number
	*/
	virtual void onBecomeBigRoom() {};
	virtual void onGotUserNumber(int num) {};
	virtual void onGotUserInfo(const std::string& jsonResult) {};
};
class TKMediaFrameObserver
{
public:
	/* local audio captured frame
	@param packet captured audio frame 
	@param id   == TK_MEDIA_FILE   media file audio frame
				== TK_MEDIA_SCREEN  screen audio frame(order by DesktopSource)
				or TK_MEDIA_MIC   microphone audio frame
	*/
	virtual bool onCaptureAudioFrame(AudioFrame& packet, TK_MEDIATYPE type) = 0;

	/* remote audio frame
	@param packet remote audio frame
	@param uid    remote user id
	@param type   == TK_MEDIA_FILE  remote media file audio frame
				  == TK_MEDIA_SCREEN remote screen frame
				  or TK_MEDIA_MIC remote microphone audio frame
	*/
	virtual bool onRenderAudioFrame(AudioFrame& packet, std::string uid, TK_MEDIATYPE type) = 0;

	/* local video captured frame
	@param packet captured video frame 
	@param id   == "media"  captured media file video frame
				== "screen" captured screen frame
				or camera device id  
	*/
	virtual bool onCaptureVideoFrame(VideoFrame& packet, const std::string& id) = 0;
	
	/* remote video frame
	@param packet remote video frame
	@param uid    remote user id
	@param type   == "media"  remote media file video frame
				  == "screen" remote screen frame
				  default is empty , if TKMULTILOCALSTREAM == true camera device id  
	*/
	virtual bool onRenderVideoFrame(VideoFrame& packet,std::string uid, const std::string& type) = 0;
};
