#ifndef _TK_DEFINITION_H_
#define _TK_DEFINITION_H_

#include "tkglobal.h"

typedef std::string  tk_uid;
typedef void*        tk_view;

#define TKMULTILOCALSTREAM  "tk_multistream"
#define TKMAXRECONNECTCOUNT "tk_max_reconnect_count"
#define TKUSESECURESOCKET	"tk_use_secure_socket"
#define TKHOST				"tk_host"
#define TKPORT				"tk_port"
#define TKVOLUMEREPORTMS    "tk_volume_report_ms"  //ص   [10~1000] 10ı

#define TKROOMID            "serial"    //
#define TKROOMPWD           "password"  //ԤԼʱָ룬עⲻͬݶӦͬ

#define ALLUSER           "__all"
#define ALLEXCEPTSENDER   "__allExceptSender"
#define ALLEXCEPTAUDITOR  "__allExceptAuditor"
#define NONEUSER          "__None"

#define TKUNUSED(a)         ((void)a)

enum TK_ERROR
{
	ERR_OK = 0,
	ERR_NOT_INITIALIZED = 1,
	ERR_INVALID_STATUS = 2,
	ERR_BAD_PARAMETERS = 3,
	ERR_NO_THIS_USER = 4,

	ERR_HTTP_REQUEST_FAILED = 11,

	ERR_OPENCAMERA_FAILED = 21,
	ERR_INVALID_VIDEO_DEV_ID = 22,

	ERR_INVALID_MIC_DEV_ID = 26,
	ERR_INVALID_SPEAKER_DEV_ID = 27,

	ERR_PUBLISH_FAILED = 31,
	ERR_PUBLISH_TIMEOUT = 32,
	ERR_PUBLISH_ROOMMAXVIDEOLIMITED = 33,
	ERR_PUBLISH_MAX_RECONNECT_COUNT = 34,

	ERR_SUBSCRIBE_FAILED = 41,
	ERR_SUBSCRIBE_TIMEOUT = 42,
	ERR_SUBSCRIBE_STREAM_NOTFOUND = 43,

	ERR_SWITCH_SERVER_FAILED = 51,
};

enum TK_WARNING
{
	
};

enum TK_INFORMATION
{
    INFO_CHECKROOM_COMPLETED = 1001,
    INFO_GETCONFIG_COMPLETED = 1002,
    
    INFO_MEDIA_STREAM_CONNECTED = 1101,
    INFO_MEDIA_STREAM_CLOSED = 1102,
};

enum TK_INTERFACE_TYPE
{
	TK_IID_AUDIO_DEVICE = 1,
	TK_IID_VIDEO_DEVICE = 2,
	TK_IID_USERMANAGER = 3,
	TK_IID_BROADCAST_ENGINE = 11,
	TK_IID_MEDIA_FACTORY = 12,
};
enum TK_ROOM_PROFILE
{
	TK_ROOM_PROFILE_COMMUNICATION = 0,  //ʵʱ
	TK_ROOM_PROFILE_LIVE_BROADCASTING = 1, //ֱ
	TL_ROOM_PROFILE_COMMUNICATION_LIVE = 2, //ֱ
};
enum TK_PUBLISH_STATUS
{
	TK_PUBLISH_NONE = 0,  //ʲô
	TK_PUBLISH_AUDIO = 1, //ֻƵ
	TK_PUBLISH_VIDEO = 2, //ֻƵ
	TK_PUBLISH_ALL = 3    //Ƶ
};
enum TK_MEDIA_STATUS
{
	TK_MEDIA_UNPUBLISH = 0,  //ֹͣ
	TK_MEDIA_PUBLISHED = 1, //ʼ
};

enum TK_RENDER_MODE
{
	TK_RENDER_MODE_HIDDEN = 1,
	TK_RENDER_MODE_FIT = 2,
	TK_RENDER_MODE_ADAPTIVE = 3,
};
enum TK_MEDIATYPE {
	TK_MEDIA_UNKNOW = -1,
	TK_MEDIA_CAMERA = 0,
	TK_MEDIA_MIC = 11,
	TK_MEDIA_SPEAKER = 12,
	TK_MEDIA_FILE = 101,
	TK_MEDIA_SCREEN = 102,
	TK_MEDIA_MEDIA = 103
};
enum TK_SOURCETYPE {
	TK_SOURCE_SCREEN = 0,
	TK_SOURCE_WINDOW = 1
};
enum TK_SAMPLEFMT {
	TK_SAMPLE_FMT_NONE = -1,
	TK_SAMPLE_FMT_U8,          ///< unsigned 8 bits
	TK_SAMPLE_FMT_S16,         ///< signed 16 bits
	TK_SAMPLE_FMT_S32,         ///< signed 32 bits
	TK_SAMPLE_FMT_FLT,         ///< float
	TK_SAMPLE_FMT_DBL,         ///< double

	TK_SAMPLE_FMT_U8P,         ///< unsigned 8 bits, planar
	TK_SAMPLE_FMT_S16P,        ///< signed 16 bits, planar
	TK_SAMPLE_FMT_S32P,        ///< signed 32 bits, planar
	TK_SAMPLE_FMT_FLTP,        ///< float, planar
	TK_SAMPLE_FMT_DBLP,        ///< double, planar
	TK_SAMPLE_FMT_S64,         ///< signed 64 bits
	TK_SAMPLE_FMT_S64P,        ///< signed 64 bits, planar

	TK_AV_SAMPLE_FMT_NB           ///< Number of sample formats. DO NOT USE if linking dynamically
};
enum TK_LOG_LEVEL {
	TK_LOG_ALL,
	TK_LOG_DEBUG,
	TK_LOG_INFO,
	TK_LOG_WARNING,
	TK_LOG_ERROR,
	TK_LOG_NONE
};
enum TK_KICKOUT_REASON {
	TK_KICKOUT_REPEAT,
	TK_KICKOUT_BY_OTHER,
};
enum TK_SERVER_REC_TYPE {
	TK_REC_INDEPENDENT_VIDEO = 1,
	TK_REC_MP3,
	TK_REC_MIXED_VIDEO,
};
enum TK_SERVER_REC_CONVERSION {
	TK_REC_CONVERT_NONE = 0,
	TK_REC_CONVERT_WEBM,
	TK_REC_CONVERT_MP4,
};
enum TK_SERVER_REC_LAYOUT {
	TK_REC_LAYOUT_HOR = 0,
	TK_REC_LAYOUT_VER,
};
enum TK_NET_QUALITY {
	TK_NET_QUALITY_EXCELLENT = 1,
	TK_NET_QUALITY_GOOD,
	TK_NET_QUALITY_ACCEPTED,
	TK_NET_QUALITY_BAD,
	TK_NET_QUALITY_VERYBAD,
	TK_NET_QUALITY_DOWN,
};
enum TK_AUDIO_DEVICE {
	TK_DEVICE_MIC,
	TK_DEVICE_SPEAKER,
};
enum TK_DEVICE_STATE {
	TK_DEVICE_REMOVE,
	TK_DEVICE_ADD,
};
enum TK_MEDIA_STATE {
	TK_MEDIA_STATE_FROZEN,
	TK_MEDIA_STATE_RESUME,
};
enum TK_VIDEO_STREAM_TYPE {
	TK_VIDEO_STREAM_BIG,
	TK_VIDEO_STREAM_SMALL
};
struct VideoProfile
{
	VideoProfile() 
		: width(320)
		, height(240)
		, maxfps(10)
	{}
	VideoProfile(int w,int h,int fps)
		: width(w)
		, height(h)
		, maxfps(fps)
	{}
	int width;
	int height;
	int maxfps;
};
typedef VideoProfile SharedProfile;
struct VideoCanvas
{
	tk_view view;
	TK_RENDER_MODE renderMode;
 
	VideoCanvas()
		: view(NULL)
		, renderMode(TK_RENDER_MODE_HIDDEN)
	{}
	VideoCanvas(tk_view v, TK_RENDER_MODE m)
		: view(v)
		, renderMode(m)
	{}
};

struct DesktopSource {
	void* window;
    int   type;
	struct Rect {
		int x, y, w, h;
	} rect;
	bool mixMic;
	bool mixSpeaker;
	bool cursorMonitor;
	DesktopSource()
		: window(0)
        , type(TK_SOURCE_SCREEN)
		, rect({ 0,0,0,0 })
		, mixMic(false)
		, mixSpeaker(false)
		, cursorMonitor(false)
	{}
};
struct ValidWindow {
	long id;
	std::string title;
};
struct VideoFrame {
	int width;  //width of video frame
	int height;  //height of video frame
	int yStride;  //stride of Y data buffer
	int uStride;  //stride of U data buffer
	int vStride;  //stride of V data buffer
	void* yBuffer;  //Y data buffer
	void* uBuffer;  //U data buffer
	void* vBuffer;  //V data buffer
	int rotation; // rotation of this frame (0, 90, 180, 270)
};
struct AudioFrame {
	int samples;  //number of samples in this frame
	int bytesPerSample;  //number of bytes per sample: 2 for PCM16
	int channels;  //number of channels (data are interleaved if stereo)
	int samplesPerSec;  //sampling rate
	int format;
	void* buffer;  // 
};
struct VideoParam {
	int width;
	int height;
	int bitrate;
	int fps;
	int key_sec;

	VideoParam()
		: width(0)
		, height(0)
		, bitrate(0)
		, fps(0)
		, key_sec(0)
	{};
};
struct AudioParam {
	int samplerate;
	int bitrate;
	int channel;
};
struct LoggerInfo {
	int loglevel; //TK_LOG_LEVEL releaseTK_LOG_WARNING
	std::string logpath;
	int limitsize; // MB. 0 for no limit

	LoggerInfo()
		: loglevel(TK_LOG_WARNING)
		, logpath("")
		, limitsize(0)
	{};
};
// ͨѶ״̬Ϣص
struct VideoStats {
	int frameWidth;
	int frameHeight;
	int frameRate;
	int packetsLost;
	int totalPackets;
	int currentDelay;
	int bitsPerSecond;
	TK_NET_QUALITY netQuality;
	double timeStamp;

	VideoStats()
		: frameWidth(0)
		, frameHeight(0)
		, frameRate(0)
		, packetsLost(0)
		, totalPackets(0)
		, currentDelay(0)
		, bitsPerSecond(0)
		, timeStamp(0)
	{};
};
struct ExtendedVideoStats : public VideoStats
{
	int firsCount;
	int plisCount;
	long long totalBytes;

	ExtendedVideoStats()
		: VideoStats()
		, firsCount(0)
		, plisCount(0)
		, totalBytes(0)
	{};
};
struct AudioStats {
	int packetsLost;
	int totalPackets;
	int currentDelay;
	int bitsPerSecond;
	int jitter;
	TK_NET_QUALITY netQuality;
	double timeStamp;

	AudioStats()
		: packetsLost(0)
		, totalPackets(0)
		, currentDelay(0)
		, bitsPerSecond(0)
		, jitter(0)
		, timeStamp(0)
	{};
};
struct ExtendedAudioStats : public AudioStats {
	long long totalBytes;

	ExtendedAudioStats()
		: AudioStats()
		, totalBytes(0)
	{};
};
struct RtcStats {
	unsigned int outBytes;
	unsigned int inBytes;
	unsigned int outPackets;
	unsigned int inPackets;
	unsigned int outAudioBitRate;
	unsigned int inAudioBitRate;
	unsigned int outVideoBitRate;
	unsigned int inVideoBitRate;
	float outAudioPacketLostRate;
	float inAudioPacketLostRate;
	float outVideoPacketLostRate;
	float inVideoPacketLostRate;
	TK_NET_QUALITY outNetQuality;
	TK_NET_QUALITY inNetQuality;
	TK_NET_QUALITY netQuality;
	unsigned int audioDelay;
	unsigned int videoDelay;
	long long duration;

	RtcStats()
		: outBytes(0)
		, inBytes(0)
		, outPackets(0)
		, inPackets(0)
		, outAudioBitRate(0)
		, inAudioBitRate(0)
		, outVideoBitRate(0)
		, inVideoBitRate(0)
		, outAudioPacketLostRate(0)
		, inAudioPacketLostRate(0)
		, outVideoPacketLostRate(0)
		, inVideoPacketLostRate(0)
		, outNetQuality(TK_NET_QUALITY_EXCELLENT)
		, inNetQuality(TK_NET_QUALITY_EXCELLENT)
		, netQuality(TK_NET_QUALITY_EXCELLENT)
		, audioDelay(0)
		, videoDelay(0)
		, duration(0)
	{};
};
struct MediaFileInfo {
	int duration;
	int width;
	int height;
	int fps;
	bool video;
	bool audio;
};
struct ServerInfo
{
	std::string chinesedesc;
	std::string englishdesc;
	std::string serverareaname;
	bool current;
};
struct Camera
{
	std::string deviceId;
	std::string deviceName;
};

#endif // !_TK_DEFINITION_H_
