#ifndef TK_GLOBAL_H_
#define TK_GLOBAL_H_

#ifdef TK_WIN
#ifdef TK_SDK_LIB
# define TK_SDK_EXPORT __declspec(dllexport)
#else
# define TK_SDK_EXPORT __declspec(dllimport)
#endif
#else
# define TK_SDK_EXPORT
#endif

#ifdef __GNUC__
#    define TK_GCC_VERSION_AT_LEAST(x,y) (__GNUC__ > (x) || __GNUC__ == (x) && __GNUC_MINOR__ >= (y))
#    define TK_GCC_VERSION_AT_MOST(x,y)  (__GNUC__ < (x) || __GNUC__ == (x) && __GNUC_MINOR__ <= (y))
#else
#    define TK_GCC_VERSION_AT_LEAST(x,y) 0
#    define TK_GCC_VERSION_AT_MOST(x,y)  0
#endif
#if TK_GCC_VERSION_AT_LEAST(3,1)
#    define tk_attribute_deprecated __attribute__((deprecated))
#elif defined(_MSC_VER)
#    define tk_attribute_deprecated __declspec(deprecated)
#else
#    define tk_attribute_deprecated
#endif

#define TK_API extern "C"

#include <string>
#include <stdint.h>
#include <map>
#include <vector>

#endif // !TK_ROOM_GLOBAL_H_

