#include <stdlib.h>
namespace tk {
	class String
	{
	public:
		String(char c);
		String(const String &s);
		String(const char *a, int len = -1);
		String();
		~String();

		int length() const;
		bool empty() const;
		void clear();
		const char *data() const;
		String substr(int pos, int len) const;

		bool contains(char c) const;
		bool contains(const char *a, int len = -1) const;
		bool contains(const String &s) const;

		int find(char c, int pos = 0) const;
		int find(const char *a, int len = -1, int pos = 0) const;
		int find(const String &s, int pos = 0) const;

		String &append(char c);
		String &append(const char *a, int len = -1);
		String &append(const String &s);

		String &insert(int pos, char c);
		String &insert(int pos, const char *a, int len = -1);
		String &insert(int pos, const String &s);

		String &replace(int pos, int len, const char c);
		String &replace(int pos, int len, const char *a, int alen = -1);
		String &replace(int pos, int len, const String &s);

		bool operator==(const String& s) const;

		bool operator!=(const String &s) const;

		String &operator=(char c);
		String &operator=(const String &s);

		String &operator+=(char c);
		String &operator+=(const String &s);

		String operator+(char c);
		String operator+(const String &s);

		const char at(int pos);
		const char operator[](int pos) const;

		short  toShort(bool *ok = NULL, int base = 10) const;
		unsigned short toUShort(bool *ok = NULL, int base = 10) const;
		int toInt(bool *ok = NULL, int base = 10) const;
		unsigned int toUInt(bool *ok = NULL, int base = 10) const;
		long toLong(bool *ok = NULL, int base = 10) const;
		unsigned long toULong(bool *ok = NULL, int base = 10) const;
		long long toLongLong(bool *ok = NULL, int base = 10) const;
		unsigned long long toULongLong(bool *ok = NULL, int base = 10) const;
		float toFloat(bool *ok = NULL) const;
		double toDouble(bool *ok = NULL) const;

		static String number(int n, int base = 10);
		static String number(unsigned int n, int base = 10);
		static String number(long n, int base = 10);
		static String number(unsigned long n, int base = 10);
		static String number(long long n, int base = 10);
		static String number(unsigned long long n, int base = 10);
	private:
		int len_;
		char* str_;
	};
} // namespace tk
